#!/usr/bin/env perl

use v5.36;
use strict;

use X11::GUITest qw[GetMousePos MoveMouseAbs ClickMouseButton SendKeys GetKeySendDelay SetKeySendDelay :CONST];
use Imager::Screenshot qw[screenshot];
use Carp;
use Time::HiRes qw(sleep);
use Data::Dumper;

my ($lastx, $lasty) = (-1, -1);

SetKeySendDelay(0);
my $delay = GetKeySendDelay();
print "KeyDelay: $delay\n";

#sleep(3);

my $bla = "abcdefghijklmnopqrstvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ01234567890";
my @chars = split//, $bla;

while(1) {
    click(1458, 727, 1);
    my $txt = '';
    for(1..int(rand(10) + 6)) {
        $txt .= $chars[int(rand(scalar @chars))];
    };
    #print "$txt\n";
    type($txt . "\n");
    sleep(0.1);
    last;
}

exit(0);

sub click($x, $y, $clickcount = 1) {
    if($x != $lastx || $y != $lasty) {
        MoveMouseAbs($x, $y, 0);
        $lastx = $x;
        $lasty = $y;
    } else {
        my ($mx, $my) = GetMousePos();
        my $dist = abs($mx - $x) + abs($my - $y);
        if($dist > 10) {
            croak("USER ABORT!");
        }
    }

    for(1..$clickcount) {
        ClickMouseButton(M_LEFT);
        sleep(0.1);
    }

    return;
}

sub type($txt, $sendcount = 1) {
    for(1..$sendcount) {
        my $temptxt = '' . $txt;
        SendKeys($temptxt);
    }
    return;
}

